package io.srandom.decision;

import java.util.Vector;
import salsa.language.Actor;
import io.core.decision.DecisionAgent;
import io.core.language.*;
import io.core.messaging.*;
import io.random.protocol.RandomSteal;
import io.random.language.RandomActorState;
import io.random.decision.RandomDecisionAgent;

public class SRandomDecisionAgent extends RandomDecisionAgent implements DecisionAgent {

	//Waiting determines if the decision agent will originate another random stealing packet.
	private boolean waiting = false;
	private IOTheater theater;

	public SRandomDecisionAgent(IOTheater _theater) {
		super(_theater);
		theater = _theater;
	}

	public IOActorState getBestCandidate() {
		//returns the best candidate actor to migrate to the given theater

		IOActorState candidate = null;

		synchronized( theater.getRegistry() ) {
			Vector registry = new Vector(theater.getRegistry().values());

			double candidateSatisfaction = -1;

			for (int i = 0; i < registry.size(); i++) {
				Object current = registry.get(i);

				if (current instanceof RandomActorState) {
					if ( !((RandomActorState)current).scheduled() && 
					     !((RandomActorState)current).satisfied() && 
					     (((RandomActorState)current).satisfaction() > candidateSatisfaction)) {
						candidate =(RandomActorState) current;
						candidateSatisfaction = candidate.satisfaction();
					}
				}
			}
		}

		return candidate;
	}
}
